/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz;

import danielcortes.xyz.controllers.ManagerController;
import danielcortes.xyz.data.Properties;
import danielcortes.xyz.models.caja.CajaDAO;
import danielcortes.xyz.models.caja.MysqlCajaDAO;
import danielcortes.xyz.models.caja.SQLiteCajaDAO;
import danielcortes.xyz.models.documentos.DocumentosDAO;
import danielcortes.xyz.models.documentos.MysqlDocumentosDAO;
import danielcortes.xyz.models.documentos.SQLiteDocumentosDAO;
import danielcortes.xyz.models.efectivo.EfectivoDAO;
import danielcortes.xyz.models.efectivo.MysqlEfectivoDAO;
import danielcortes.xyz.models.efectivo.SQLiteEfectivoDAO;
import danielcortes.xyz.models.egreso.EgresoDAO;
import danielcortes.xyz.models.egreso.MysqlEgresoDAO;
import danielcortes.xyz.models.egreso.SQLiteEgresoDAO;
import danielcortes.xyz.models.ingreso.IngresoDAO;
import danielcortes.xyz.models.ingreso.MysqlIngresoDAO;
import danielcortes.xyz.models.ingreso.SQLiteIngresoDAO;
import danielcortes.xyz.models.tipo_egreso.MysqlTipoEgresoDAO;
import danielcortes.xyz.models.tipo_egreso.SQLiteTipoEgresoDAO;
import danielcortes.xyz.models.tipo_egreso.TipoEgresoDAO;
import danielcortes.xyz.models.tipo_ingreso.MysqlTipoIngresoDAO;
import danielcortes.xyz.models.tipo_ingreso.SQLiteTipoIngresoDAO;
import danielcortes.xyz.models.tipo_ingreso.TipoIngresoDAO;
import danielcortes.xyz.views.ManagerView;
import javax.swing.*;
import java.util.Locale;

public class Main {
    public static void main(String[] args) {
        run();
    }

    private static void run() {
        System.setProperty("awt.useSystemAAFontSettings", "on");
        System.setProperty("swing.aatext", "true");

        try {
            UIManager.setLookAndFeel(Properties.getInstance().getProperty("look_and_feel"));
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException e) {
            e.printStackTrace();
        }

        Locale.setDefault(new Locale("es"));


        CajaDAO cajaDAO = null;
        DocumentosDAO documentosDAO = null;
        EfectivoDAO efectivoDAO = null;
        EgresoDAO egresoDAO = null;
        IngresoDAO ingresoDAO = null;
        TipoEgresoDAO tipoEgresoDAO = null;
        TipoIngresoDAO tipoIngresoDAO = null;

        if (Properties.getInstance().getProperty("database_type").equals("mysql")) {
            cajaDAO = new MysqlCajaDAO();
            documentosDAO = new MysqlDocumentosDAO();
            efectivoDAO = new MysqlEfectivoDAO();
            egresoDAO = new MysqlEgresoDAO();
            ingresoDAO = new MysqlIngresoDAO();
            tipoEgresoDAO = new MysqlTipoEgresoDAO();
            tipoIngresoDAO = new MysqlTipoIngresoDAO();
        } else if (Properties.getInstance().getProperty("database_type").equals("sqlite")) {
            cajaDAO = new SQLiteCajaDAO();
            documentosDAO = new SQLiteDocumentosDAO();
            efectivoDAO = new SQLiteEfectivoDAO();
            egresoDAO = new SQLiteEgresoDAO();
            ingresoDAO = new SQLiteIngresoDAO();
            tipoEgresoDAO = new SQLiteTipoEgresoDAO();
            tipoIngresoDAO = new SQLiteTipoIngresoDAO();
        }

        ManagerView view = new ManagerView();
        ManagerController managerController = new ManagerController(view, cajaDAO, documentosDAO, efectivoDAO, egresoDAO, ingresoDAO, tipoEgresoDAO, tipoIngresoDAO);

        JFrame frame = new JFrame("Caja");
        frame.setContentPane(view.getContentPanel());
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //frame.setSize(780, 450);
        frame.pack();
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
    }
}
